Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2437 by niro, Tue Jan 7 14:28:13 2014 UTC revision 2499 by niro, Wed Jan 8 13:19:29 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  # ignore the environment  # setup locales
11  LC_ALL=C  TEXTDOMAIN=installer
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
15    
# Line 70  SPECIALDEVICE="" Line 71  SPECIALDEVICE=""
71  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
72  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
73    
74  #################################################  
75  #  DIALOG BOXEN #  ### helper scripts ###
 #################################################  
76    
77  trap_exit()  trap_exit()
78  {  {
# Line 86  trap_exit() Line 86  trap_exit()
86   exit 1   exit 1
87  }  }
88    
 dialog_die()  
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
 {  
  local retval  
   
  yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"  
  retval=$?  
  if [[ ${retval} -eq 1 ]]  
  then  
  clear  
  echo $"The process was aborted."  
  exit 1  
  fi  
 }  
   
 dialog_setup_hdd_info()  
 {  
  local SHDD="${HDD//\/dev\/}"  
   
  messagebox -h $"[ Harddrive partitioning ]" \  
  $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."  
 }  
   
 dialog_setup_hdd_info_auto()  
 {  
  local SHDD="${HDD//\/dev\/}"  
   
  messagebox -h $"[ Harddrive partitioning ]" \  
  $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"  
 }  
   
 dialog_setup_system_menu()  
 {  
  local mode  
  local retval  
   
  mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \  
  $"1:Automatic setup (recommended)" \  
  ":" \  
  $":\Z1Expert modes:\Zn" \  
  $"2:Common IDE-disk (manual setup)")  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case "${mode}" in  
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") dialog_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local message  
   
  run_hardware_detection_disks  
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
  then  
  for i in ${ALL_DISKS}  
  do  
  message+="\Z3${i}\Zn "  
  done  
  message+="\n"  
  fi  
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  message+="\n"  
  message+=$"Optical disk drives:\n"  
  for i in ${ALL_CDROMS}  
  do  
  message+="\Z3${i}\Zn"  
  done  
  message+="\n"  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n \\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"  
  fi  
   
  messagebox -y 15 -h $"Detected hardware:" "${message}"  
 }  
   
 dialog_setup_hdd_partitions_manual()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info  
  setup_hdd_partitions_manual  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_auto()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
  fi  
 }  
   
89  install_meter()  install_meter()
90  {  {
91   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
# Line 246  install_meter() Line 99  install_meter()
99   return 0   return 0
100  }  }
101    
102  dialog_main()  mount_rootfs()
103  {  {
  local method=0  
104   local retval   local retval
105    
106   while [[ ${method} -le 2 ]]   if is_mounted --location "${INSTALLROOT}"
107   do   then
108   method=$(menubox $"Configuration:" \   echo $"${INSTALLROOT} already mounted" >&2
109   $"1:Install system" \   else
110   $"2:Show detected harddrives" \   mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
111   $"3:Exit and reboot" \   fi
112   $"4:Exit and drop into a shell")   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
113   retval=$?  }
114   [[ ${retval} -eq 1 ]] && exit 1  
115   if [[ ${retval} -eq 0 ]]  umount_rootfs()
116   then  {
117   case ${method} in   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
118   "1") dialog_setup_system_menu ;;   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
119   "2") dialog_hardware_detection ;;  }
120   "3") install_do_reboot ;;  
121   "4") /bin/bash --login -i ;;  install_do_reboot()
122   esac  {
123   fi   reboot
  done  
124  }  }
125    
 #################################################  
 # Install Komandos #  
 #################################################  
126  run_hardware_detection()  run_hardware_detection()
127  {  {
128   local hwinfo   local hwinfo
# Line 348  run_hardware_detection_disks() Line 196  run_hardware_detection_disks()
196   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
197  }  }
198    
 hdd_size_below_256mb()  
 {  
  local hdd="$1"  
  local size  
  local retval  
  [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"  
   
  size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')  
  if [[ ${size} -le 257000000 ]]  
  then  
  retval="0"  
  else  
  retval="1"  
  fi  
   
  return "${retval}"  
 }  
   
199  setup_hdd_partitions_auto()  setup_hdd_partitions_auto()
200  {  {
201   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
# Line 380  setup_hdd_partitions_auto() Line 210  setup_hdd_partitions_auto()
210   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
211   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
212   then   then
213   if hdd_size_below_256mb ${HDD}   if device_minimum_size "${HDD}" 256
214   then   then
215   FDISKPARTIONBELOW256MB=1   FDISKPARTIONBELOW256MB=1
216   else   else
# Line 455  setup_hdd_format() Line 285  setup_hdd_format()
285   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
286  }  }
287    
 install_mount_rootfs()  
 {  
  is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"  
  install -d ${INSTALLROOT}/boot || dialog_die  
 }  
   
288  install_system_image()  install_system_image()
289  {  {
290   pushd ${INSTALLROOT} > /dev/null   pushd ${INSTALLROOT} > /dev/null
# Line 468  install_system_image() Line 292  install_system_image()
292   popd > /dev/null   popd > /dev/null
293  }  }
294    
295  install_bootsector_chroot()  install_system_settings()
296  {  {
297   local my_roothdd   local CONFIG
  local grubconf=${INSTALLROOT}/boot/grub/grub.conf  
  local grub2conf=/boot/grub/grub.cfg  
298    
299   # check for grub2   # write fstab
300   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]   CONFIG="${INSTALLROOT}/etc/fstab"
301   then   clearconfig
302   # needed by grub-mkconfig on the first run   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
303   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
304   then   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
  install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die  
  fi  
305    
306   # set kernelopts   # install network config skeleton
307   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
308   then   clearconfig
309   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die   addconfig 'ONBOOT="yes"'
310   else   addconfig 'NETWORKING="dhcp"'
  echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  fi  
  echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die  
   
  # grub-legacy  
  else  
  ### grubconf schreiben  
  source ${INSTALLROOT}/boot/kernelversion  
311    
312   #for alx only   # intel framebuffer quirk
313   if [ -e ${INSTALLROOT}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]
314     then
315     if [ -e /proc/fb ]
316   then   then
317   OLD_ALXVER="${ALXVER}"   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
318   source ${INSTALLROOT}/etc/alx_version   then
319   KRNVER="ALX-${ALXVER}"   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
320   ALXVER="${OLD_ALXVER}"   if [[ ${fbdev} != 0 ]]
321     then
322     sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
323     fi
324     fi
325   fi   fi
326     fi
327    }
328    
  [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"  
  [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"  
  [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"  
329    
330   # uuid support  ### installer dialogs ###
  if is_uuid_supported  
  then  
  my_roothdd="UUID=$(get_uuid ${ROOTHDD})"  
  else  
  my_roothdd="${ROOTHDD}"  
  fi  
   
  : > ${grubconf} || dialog_die  
  echo "default 0" >> ${grubconf} || dialog_die  
  echo "timeout 3" >> ${grubconf} || dialog_die  
  # using current root password  
  echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die  
   
  echo  >> ${grubconf} || dialog_die  
  echo "# normal boot" >> ${grubconf} || dialog_die  
  echo "title ${KRNVER}" >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
331    
332   echo >> ${grubconf} || dialog_die  dialog_die()
333   echo "# admin boot" >> ${grubconf} || dialog_die  {
334   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die   ERROR="$1"
335   echo "lock"  >> ${grubconf} || dialog_die   RETVAL="$?"
336   echo "root (hd0,0)" >> ${grubconf} || dialog_die   dialog_install_failure
337   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die   exit 1
338   if is_initrd_supported  }
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
339    
340   echo >> ${grubconf} || dialog_die  dialog_warning()
341   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die  {
342   echo "lock"  >> ${grubconf} || dialog_die   local retval
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
343    
344   # bootsector schreiben chrooted schreiben (lfs/magellan)   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
345   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   retval=$?
346  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null   if [[ ${retval} -eq 1 ]]
347  root (hd0,0)   then
348  setup (hd0)   clear
349  quit   echo $"The process was aborted."
350  EOF   exit 1
 exit 0  
 CHROOTEOF  
351   fi   fi
   
  # run installrc  
  chrooted /bin/bash --rcfile /root/.installrc -i  
  rm ${INSTALLROOT}/root/.installrc  
352  }  }
353    
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0  
  return 1  
 }  
354    
355  install_initrd_chroot()  ### installer tasks ###
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
356    
357   DISKMODS="sd_mod"  task_setup_system_menu()
358   OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  {
359   PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"   local mode
360   SATAMODS="sata_via sata_sis sata_nv"   local retval
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
361    
362   if [[ ${FORMFACTOR} = laptop ]]   mode="$(dialog_setup_system_menu)"
363     retval=$?
364     [[ ${retval} -eq 1 ]] && return 1
365     if [[ ${retval} -eq 0 ]]
366   then   then
367   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   case "${mode}" in
368     "1") run_install_auto ;;
369     "2") run_install_normal ;;
370     "") task_setup_system_menu;;
371     esac
372   fi   fi
373    }
374    
375   # install an appropriate uvesafb.conf  task_hardware_detection()
376   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die  {
377   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die   local message
378    
379   # install an appropriate viafb.conf   run_hardware_detection_disks
  echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die  
380    
381   # install an appropriate i810fb.conf   message+=$"Harddrives:\n"
  echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die  
382    
383   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   if [[ ! -z ${ALL_DISKS} ]]
384  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd   then
385  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null   for i in ${ALL_DISKS}
386  exit 0   do
387  CHROOTEOF   message+="\Z3${i}\Zn "
388     done
389     message+="\n"
390     fi
391    
392   # run installrc   if [[ ! -z ${ALL_CDROMS} ]]
393   chrooted /bin/bash --rcfile /root/.installrc -i   then
394   rm ${INSTALLROOT}/root/.installrc   message+="\n"
395  }   message+=$"Optical disk drives:\n"
396     for i in ${ALL_CDROMS}
397     do
398     message+="\Z3${i}\Zn"
399     done
400     message+="\n"
401     fi
402    
403  is_uuid_supported()   # other devices
404  {   run_hardware_detection
405   if [[ -x $(type -P busybox.mkinitrd) ]]   case "${SPECIALDEVICE}" in
406     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
407     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
408     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
409     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
410     esac
411     if [[ ${FORMFACTOR} = laptop ]]
412   then   then
413   # only detect uuids if supported   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
  if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]  
  then  
  return 0  
  fi  
414   fi   fi
415    
416   return 1   messagebox -y 12 -h $"Detected hardware:" "${message}"
417  }  }
418    
419  get_uuid()  task_setup_hdd_partitions_manual()
420  {  {
421   local UUID   local i
422   local SEC_TYPE   local retval
  local TYPE  
   
  local dev="$1"  
  [[ -z ${dev} ]] && dialog_die "no dev given"  
423    
424   # check if given device is already an UUID   if [[ -z ${ALL_DISKS} ]]
  if [[ ${dev/UUID=/}x != ${dev}x ]]  
425   then   then
426   eval "${dev}"   dialog_no_harddrive_found
427     exit 1
428   else   else
429   eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')   HDD=$(dialog_select_target_harddrive)
430     retval=$?
431     [[ ${retval} -eq 1 ]] && return 1
432     if [[ ${retval} -eq 0 ]]
433     then
434     dialog_setup_hdd_info
435     setup_hdd_partitions_manual
436     fi
437   fi   fi
  echo "${UUID}"  
438  }  }
439    
440  install_system_settings()  task_setup_hdd_partitions_auto()
441  {  {
442   # schreibe fstab   local i
443   if is_uuid_supported   local retval
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  fi  
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
   
  # install network config skeleton  
  install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die  
444    
445   # intel framebufer quirk   if [[ -z ${ALL_DISKS} ]]
  if [[ -e /proc/fb ]]  
446   then   then
447   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   dialog_no_harddrive_found
448     exit 1
449     else
450     HDD=$(dialog_select_target_harddrive)
451     retval=$?
452     [[ ${retval} -eq 1 ]] && return 1
453     if [[ ${retval} -eq 0 ]]
454   then   then
455   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   dialog_setup_hdd_info_auto
456   if [[ ${fbdev} != 0 ]]   dialog_setup_hdd_create_partitions
457   then   setup_hdd_partitions_auto
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
458   fi   fi
459   fi   fi
460  }  }
461    
462  install_umount_rootfs()  task_main()
463  {  {
464   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot   local method=0
465   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}   local retval
 }  
466    
467  install_do_reboot()   while [[ ${method} -le 2 ]]
468  {   do
469   reboot   method=$(dialog_main)
470     retval=$?
471     [[ ${retval} -eq 1 ]] && exit 1
472     if [[ ${retval} -eq 0 ]]
473     then
474     case ${method} in
475     "1") task_setup_system_menu ;;
476     "2") task_hardware_detection ;;
477     "3") install_do_reboot ;;
478     "4") /bin/bash --login -i ;;
479     esac
480     fi
481     done
482  }  }
483    
 #################################################  
 #     Install Ablauf Scripte #  
 #################################################  
   
484  run_install_normal()  run_install_normal()
485  {  {
486   dialog_hardware_detection   task_hardware_detection
487    
488   dialog_setup_hdd_partitions_manual   task_setup_hdd_partitions_manual
489   dialog_setup_hdd_format   dialog_setup_hdd_format
490   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
491   install_mount_rootfs   mount_rootfs
492   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
493    
494   dialog_install_settings   dialog_install_settings
495   sleep 1   sleep 1
496   install_system_settings   install_system_settings
497   dialog_install_initrd   if is_initrd_supported
498   install_initrd_chroot   then
499     dialog_install_initrd
500     initrd_config
501     initrd_install
502     fi
503    
504   dialog_install_bootsector   dialog_install_bootsector
505   install_bootsector_chroot   bootloader_config
506     bootloader_install
507    
508   install_umount_rootfs   umount_rootfs
509   dialog_install_successful   dialog_install_successful
510  }  }
511    
512  run_install_auto()  run_install_auto()
513  {  {
514   dialog_hardware_detection   task_hardware_detection
515    
516   dialog_setup_hdd_partitions_auto   task_setup_hdd_partitions_auto
517   dialog_setup_hdd_format   dialog_setup_hdd_format
518   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
519   install_mount_rootfs   mount_rootfs
520   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
521    
522   dialog_install_settings   dialog_install_settings
523   sleep 1   sleep 1
524   install_system_settings   install_system_settings
525   dialog_install_initrd   if is_initrd_supported
526   install_initrd_chroot   then
527     dialog_install_initrd
528     initrd_config
529     initrd_install
530     fi
531    
532   dialog_install_bootsector   dialog_install_bootsector
533   install_bootsector_chroot   bootloader_config
534     bootloader_install
535    
536   install_umount_rootfs   umount_rootfs
537   dialog_install_successful   dialog_install_successful
538  }  }
539    
540  # set some proper traps  # set some proper traps
541  trap "trap_exit" SIGINT SIGQUIT  trap "trap_exit" SIGINT SIGQUIT
542    
543  dialog_main  task_main
544    
545  exit 0  exit 0

Legend:
Removed from v.2437  
changed lines
  Added in v.2499